package de.mdelab.mlsdm.interpreter.debug;

import de.mdelab.mlcore.MLElementWithUUID;
import de.mdelab.mlexpressions.MLExpression;
import de.mdelab.mlsdm.Activity;
import de.mdelab.mlsdm.ActivityNode;
import de.mdelab.mlsdm.interpreter.MLSDMInterpreter;
import de.mdelab.mlsdm.interpreter.debug.protocol.MLSDMDebugProtocolCommandIndicationFactory;
import de.mdelab.mlstorypatterns.StoryPattern;
import de.mdelab.resourceSetSynchronizer.EObjectUuidCalculator;
import de.mdelab.sdm.interpreter.core.debug.SDDebugger;
import de.mdelab.sdm.interpreter.core.debug.protocol.SDDebugProtocolCommandIndicationFactory;

public class MLSDMDebugger extends SDDebugger<MLElementWithUUID, Activity, ActivityNode, StoryPattern, MLExpression> {
//	public static final int	MLSDM_DEBUG_SERVER_DEFAULT_PORT	= 19001;

	public MLSDMDebugger(	final MLSDMInterpreter p_interpreter, 
							final int pi_debugServerPort,
							final int pi_resourceSetSynchronizerPort ) {
		super( p_interpreter, pi_debugServerPort, pi_resourceSetSynchronizerPort );
	}

//	public MLSDMDebugger(final MLSDMInterpreter interpreter)
//	{
//		this( interpreter, MLSDMDebugger.MLSDM_DEBUG_SERVER_DEFAULT_PORT );
//	}

	@Override
	protected SDDebugProtocolCommandIndicationFactory<MLElementWithUUID> createDebugProtocolCommandIndicationFactory()
	{
		return new MLSDMDebugProtocolCommandIndicationFactory(this);
	}

	private MLSDMElementUuidCalculator	storyDiagramElementUuidCalculator;

	@Override
	protected EObjectUuidCalculator getStoryDiagramElementUuidCalculator()
	{
		if (this.storyDiagramElementUuidCalculator == null)
		{
			this.storyDiagramElementUuidCalculator = new MLSDMElementUuidCalculator();
		}

		return this.storyDiagramElementUuidCalculator;
	}

}
