package de.mdelab.mlsdm.interpreter.debug.protocol;

import org.eclipse.net4j.signal.SignalProtocol;
import org.eclipse.net4j.signal.SignalReactor;

import de.mdelab.mlcore.MLElementWithUUID;
import de.mdelab.mlexpressions.MLExpression;
import de.mdelab.mlsdm.interpreter.debug.protocol.indications.SetBreakpointCommandIndication;
import de.mdelab.sdm.interpreter.core.debug.SDDebugger;
import de.mdelab.sdm.interpreter.core.debug.protocol.SDDebugProtocolCommandIndicationFactory;

public class MLSDMDebugProtocolCommandIndicationFactory extends SDDebugProtocolCommandIndicationFactory<MLElementWithUUID>
{

	private final SDDebugger<MLElementWithUUID, ?, ?, ?, MLExpression>	debugger;

	public MLSDMDebugProtocolCommandIndicationFactory(final SDDebugger<MLElementWithUUID, ?, ?, ?, MLExpression> debugger)
	{
		super(debugger);

		this.debugger = debugger;
	}

	@Override
	protected SignalReactor createSetBreakpointCommandIndication(final SignalProtocol<?> protocol)
	{
		return new SetBreakpointCommandIndication(protocol, this.debugger);
	}

}
