package de.mdelab.mlsdm.interpreter.debug.ui;

import java.io.IOException;

import org.eclipse.core.resources.IResource;
import org.eclipse.core.runtime.CoreException;
import org.eclipse.core.runtime.IStatus;
import org.eclipse.core.runtime.Status;
import org.eclipse.emf.common.ui.URIEditorInput;
import org.eclipse.emf.common.util.URI;
import org.eclipse.ui.IEditorInput;

import de.mdelab.mlsdm.interpreter.debug.ui.mlsdmEditor.MLSDMDebuggerStoryDiagramEditor;
import de.mdelab.mlsdm.interpreter.debug.ui.mlsdmEditor.MLSDMEditorManager;
import de.mdelab.sdm.interpreter.code.debug.ui.SDDebugModelPresentation;
import de.mdelab.sdm.interpreter.code.debug.ui.breakpoints.SDDebugBreakpoint;

public class MLSDMDebugModelPresentation extends SDDebugModelPresentation {

	public MLSDMDebugModelPresentation() {
		super();
	}

	@Override
	protected IEditorInput getEditorInput( final SDDebugBreakpoint p_sdBreakpoint ) 
	throws CoreException {
		final IResource resource = p_sdBreakpoint.getMarker().getResource();

		try {
			final URI diagUri = MLSDMEditorManager.getDiagramURI( URI.createPlatformResourceURI( resource.getFullPath().toString(), true ) );
			
			return new URIEditorInput( diagUri );
		} 
		catch ( final IOException p_ex ) {
			throw new CoreException( new Status( IStatus.ERROR, IMLSDMDebugUiConstants.PLUGIN_ID, "", p_ex ) );
		}
	}

	@Override
	protected String getEditorId( final SDDebugBreakpoint p_sdBreakpoint ) {
		return MLSDMDebuggerStoryDiagramEditor.ID;
	}
}
