package de.mdelab.mlsdm.interpreter.debug.ui;

import org.eclipse.debug.core.DebugException;

import de.mdelab.mlcore.MLElementWithUUID;
import de.mdelab.mlcore.MLNamedElement;
import de.mdelab.mlsdm.Activity;
import de.mdelab.sdm.interpreter.code.debug.ui.SDDebugTarget;
import de.mdelab.sdm.interpreter.code.debug.ui.SDDebugThread;
import de.mdelab.sdm.interpreter.code.debug.ui.SDDebugUiStackFrame;
import de.mdelab.sdm.interpreter.core.debug.client.stack.DebugClientStackFrame;

public class MLSDMDebugUiStackFrame extends SDDebugUiStackFrame<MLElementWithUUID>
{

	public MLSDMDebugUiStackFrame(final SDDebugTarget<MLElementWithUUID, Activity> target,
			final SDDebugThread<MLElementWithUUID, Activity> debugThread, final DebugClientStackFrame<MLElementWithUUID> stackFrame)
	{
		super(target, debugThread, stackFrame);
	}

	@Override
	public String getName() 
	throws DebugException {
		final MLElementWithUUID sdElement = getStackFrame().getStoryDiagramElement();
		
		if ( sdElement.eResource() != null ) {
			final StringBuilder stringBuilder = new StringBuilder( sdElement.eResource().getURI().lastSegment() );
			stringBuilder.append( ": " );

			if ( sdElement instanceof MLNamedElement &&  ((MLNamedElement) sdElement ).getName() != null )	{
				stringBuilder.append( ( (MLNamedElement) sdElement ).getName() );
				stringBuilder.append( ": " );
			}

			stringBuilder.append( sdElement.eClass().getName() );

			stringBuilder.append(" (");
			stringBuilder.append( getStackFrame().getLastNotificationType().name() );
			stringBuilder.append(")");

			return stringBuilder.toString();
		}

		return "";
	}
}
