package de.mdelab.mlsdm.interpreter.debug.ui.launcher;

import java.io.OutputStream;
import java.util.List;
import java.util.Map;

import org.eclipse.core.runtime.CoreException;
import org.eclipse.core.runtime.IProgressMonitor;
import org.eclipse.debug.core.ILaunch;
import org.eclipse.debug.core.model.IDebugTarget;
import org.eclipse.emf.common.util.URI;
import org.eclipse.emf.ecore.EClassifier;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.ecore.resource.Resource;

import de.mdelab.mlsdm.Activity;
import de.mdelab.mlsdm.interpreter.debug.ui.MLSDMDebugTarget;
import de.mdelab.mlsdm.interpreter.debug.ui.MLSDMRunTarget;
import de.mdelab.sdm.interpreter.code.debug.ui.launcher.SDInterpreterLaunchDelegate;
import de.mdelab.sdm.interpreter.code.debug.ui.launcher.SDServerThread;
import de.mdelab.sdm.interpreter.core.variables.Variable;

public class MLSDMInterpreterLaunchDelegate extends SDInterpreterLaunchDelegate<Activity, EClassifier> {

	@Override
	protected Variable<EClassifier> createVariable(	final String p_varName,
													final EObject p_varValue) {
		return new Variable<EClassifier>( p_varName, p_varValue.eClass(), p_varValue );
	}

	@Override
	protected SDServerThread<Activity, EClassifier> createServerThread( final Activity p_activity,
																		final List<Variable<EClassifier>> p_variableBindings,
																		final Integer p_serverPort, 
																		final Integer p_resourceSetSynchronizerPort,
																		final IProgressMonitor p_monitor, 
																		final OutputStream p_messageStream,
																		final Map<Resource, URI> p_instanceModels, 
																		final boolean pb_logOutput,
																		final String p_execTraceUriStr ) {
		return new MLSDMServerThread( 	p_activity, 
										p_variableBindings,
										p_serverPort,
										p_resourceSetSynchronizerPort,
										p_monitor,
										p_messageStream,
										p_instanceModels,
										pb_logOutput,
										p_execTraceUriStr );
	}

	@Override
	protected IDebugTarget createDebugTarget( 	final ILaunch p_launch,
												final String p_serverAddress,
												final int pi_serverPort,
												final int pi_clientPort,
												final int pi_resSetSyncPort )
	throws CoreException {
		return new MLSDMDebugTarget( p_launch, p_serverAddress, pi_serverPort, pi_clientPort, pi_resSetSyncPort );
	}

	@Override
	protected IDebugTarget createRunTarget( final ILaunch p_launch) {
		return new MLSDMRunTarget( p_launch );
	}
}
